#ifndef __FEAT_MODEL__
#define __FEAT_MODEL__

#include "feat_desc.h"

typedef struct {
  char string[2048];
  char *name;
  int nbelem;
  feat_desc **array;
  int dim;
} feat_model;

#include "config.h"
#include "dico.h"
#include "mcd.h"



void feat_model_free(feat_model *fm);
feat_model *feat_model_new(char *name);
feat_desc *feat_model_add(feat_model *fm, feat_desc *fd);
int feat_model_get_feat_value_fann(feat_model *fm, config *c, int feat_nb);
int feat_model_get_feat_value_cff(feat_model *fm, config *c, dico *dico_features, int feat_nb, int mode);
feat_model *feat_model_read(char *filename, int verbose);
void feat_model_compute_ranges(feat_model *fm, mcd *m, int mvt_nb);
#endif
