#ifndef __MOVEMENT_PARSER_ARC_EAGER__
#define __MOVEMENT_PARSER_ARC_EAGER__

#include"config.h"
#include"feat_vec.h"


#define MVT_SHIFT 0
#define MVT_REDUCE 1
#define MVT_ROOT 2
#define MVT_EOS 3
#define MVT_LEFT 4
#define MVT_RIGHT 5


/* even movements are left movements (except 0, which is shift and 2 which is root) */
#define movement_left_code(label) (2 * (label) + 4)

/* odd movements are right movements  (except 1, which is reduce and 3 which is end_of_sentence) */
#define movement_right_code(label) (2 * (label) + 5)

int movement_type(int mvt);
int movement_label(int mvt);

int movement_left_arc(config *c, int label, float score);
int movement_right_arc(config *c, int label, float score);
int movement_shift(config *c, int stream, float score);
int movement_reduce(config *c, float score);
int movement_root(config *c, float score, int root_code);
int movement_eos(config *c, float score);
void movement_print(FILE *f, int mvt_code, dico *dico_labels);

#endif
