#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include"word_buffer.h"
#include"movement_parser_arc_eager.h"

int check_all_dependents_of_word_in_ref_are_in_hyp(config *c, word_buffer *ref, int word_index, int start_sentence_index)
{
  int dep;
  int gov_ref;
  int gov_hyp;
  int max_sent_length = 300;
  int max = ((start_sentence_index + max_sent_length) > ref->nbelem)? ref->nbelem : (start_sentence_index + max_sent_length);
  for(dep=start_sentence_index; dep < max; dep++){
    gov_ref = word_get_gov_index(word_buffer_get_word_n(ref, dep)); 
    if(gov_ref  == word_index){ /* found a dependent of word in ref */
      /* look for a dependency in hyp such that its dependent is dep */
       /* printf("found a dep of word %d in ref, it is %d\n", word_index, dep);  */
      gov_hyp = word_get_gov_index(word_buffer_get_word_n(config_get_buffer(c), dep));
      
 /* printf("gov of %d in hyp is %d\n", dep,gov_hyp);  */
      if(gov_hyp != gov_ref) return 0;
      /*      
      if((dep >= c->ds->length)
	 || (c->ds->array[dep].gov == NULL)
	 || (word_get_index(c->ds->array[dep].gov) != word_index)
	 || (c->ds->array[dep].label != word_get_label(ref->words[dep])))
	 return 0;*/
    }
  }
  return 1;
}

int oracle_parser_arc_eager(config *c, word_buffer *ref, int start_sentence_index, int root_label)
{
  word *s0; /* word on top of stack */
  word *b0; /* next word in the bufer */
  int s0_index, b0_index;
  int s0_gov_index, b0_gov_index;
  int b0_label;
  int b0_label_in_hyp;

  b0 = word_buffer_b0(config_get_buffer(c));
  b0_index = word_get_index(b0);
  b0_gov_index = word_get_gov_index(word_buffer_get_word_n(ref, b0_index));
  b0_label = word_get_label(word_buffer_get_word_n(ref, b0_index));
  b0_label_in_hyp = word_get_label(word_buffer_get_word_n(config_get_buffer(c), b0_index));
  
  /* b0 is the root of the sentence */
  if((b0_label == root_label) && (b0_label_in_hyp != root_label)){
    return MVT_ROOT;
  }
  
  /* if(!stack_is_empty(config_get_stack(c)) && !word_buffer_is_empty(config_get_buffer(c))){ */
  if(!stack_is_empty(config_get_stack(c))){
    s0 = stack_top(config_get_stack(c));
    s0_index = word_get_index(s0);
    s0_gov_index = word_get_gov_index(word_buffer_get_word_n(ref, s0_index));
    
    /*    printf("s0_index = %d b0_index = %d\n", s0_index, b0_index);  
	  printf("dans ref gov de s0 (%d) = %d\n", s0_index, s0_gov_index);
	  printf("dans ref gov de b0 (%d) = %d\n", b0_index, b0_gov_index);*/

    /* word on the top of the stack is an end of sentence marker */
    if(word_get_sent_seg(s0) == 1){
      return MVT_EOS;
    }

    /* LEFT ARC  b0 is the governor and s0 the dependent */
    if(s0_gov_index == b0_index){
      return movement_left_code(word_get_label(word_buffer_get_word_n(ref, s0_index)));
    }
    
    /* RIGHT ARC s0 is the governor and b0 the dependent */
    if(b0_gov_index == s0_index){
      return movement_right_code(word_get_label(word_buffer_get_word_n(ref, b0_index))); 
    }
    /* REDUCE */
    if(
       /* (stack_height(config_get_stack(c)) > 2) */
       check_all_dependents_of_word_in_ref_are_in_hyp(c, ref, s0_index, start_sentence_index)
       && (word_get_gov(stack_top(config_get_stack(c))) != 0)) /* word on top of the stack has a goveror */
      {
	return MVT_REDUCE;
      }
  }

  /* SHIFT */
  return MVT_SHIFT;

}
